package A;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
import javax.swing.event.*;
//******************************************************************************
public class A extends JFrame {
    DisplayPanel displayPanel;
    JButton reverseButton,resetButton;
    JSlider redBar,grnBar,bluBar,allBar;
    public  int red   =50;
    public  int green =50;
    public  int blue  =50;
    public  int all   =50;
    public  int alfa  =255;
    int w    = 600;
    int h    = 600;
    int[] pixels = new int[w*h];
    int alfas,reds,greens,blues;
    double di = 2.55;
//******************************************************************************
    public A() {
        super();
        Container container = getContentPane();
        displayPanel = new DisplayPanel();
        container.add(displayPanel);
        JPanel panel = new JPanel();
        panel.setLayout(new GridLayout(3, 2));
        reverseButton = new JButton("invertuoti");
        reverseButton.addActionListener(new ButtonListener());
        redBar = new JSlider(JSlider.HORIZONTAL, 0, 100, red);
        redBar.setBackground(Color.red);
        redBar.setMajorTickSpacing(50);
        redBar.setMinorTickSpacing(10);
        redBar.setPaintTicks(true);
        redBar.setPaintLabels(true);
        redBar.addChangeListener(new ColorListener());
        grnBar = new JSlider(JSlider.HORIZONTAL, 0, 100, green);
        grnBar.setBackground(Color.green);
        grnBar.setMajorTickSpacing(50);
        grnBar.setMinorTickSpacing(10);
        grnBar.setPaintTicks(true);
        grnBar.setPaintLabels(true);
        grnBar.addChangeListener(new ColorListener());
        bluBar = new JSlider(JSlider.HORIZONTAL, 0, 100, blue);
        bluBar.setBackground(Color.blue);
        bluBar.setMajorTickSpacing(50);
        bluBar.setMinorTickSpacing(10);
        bluBar.setPaintTicks(true);
        bluBar.setPaintLabels(true);
        bluBar.addChangeListener(new ColorListener());
        allBar = new JSlider(JSlider.HORIZONTAL, 0, 100, all);
        allBar.setBackground(Color.BLACK);
        allBar.setMajorTickSpacing(50);
        allBar.setMinorTickSpacing(10);
        allBar.setPaintTicks(true);
        allBar.setPaintLabels(true);
        allBar.addChangeListener(new ColorListener());
        panel.add(redBar);
        panel.add(bluBar);
        panel.add(allBar);
        panel.add(grnBar);       
        panel.add(reverseButton);
        container.add(BorderLayout.NORTH, panel);
        addWindowListener(new WindowEventHandler());
        setSize(displayPanel.getWidth(), displayPanel.getHeight() + 25);
        show();
    }
//******************************************************************************
    class WindowEventHandler extends WindowAdapter {
        public void windowClosing(WindowEvent e) {
            System.exit(0);
        }
    }
//******************************************************************************
    public static void main(String arg[]) {
        A frame =new A();
        frame.setSize(860, 640);
    }
    class ColorListener implements ChangeListener {
        public void stateChanged(ChangeEvent ae) {
            JSlider slider = (JSlider) ae.getSource();
            if(slider.equals(redBar)){
                red=redBar.getValue();
                red=(int)(red*di);
                displayPanel.change();
                displayPanel.repaint();
            }
            if(slider.equals(grnBar)){
                green =grnBar.getValue();
                green=(int)(green*di);
                displayPanel.change();
                displayPanel.repaint();
            }
            if(slider.equals(bluBar)){
                blue  =bluBar.getValue();
                blue=(int)(blue*di);
                displayPanel.change();
                displayPanel.repaint();
            }
            if(slider.equals(allBar)){
                all=allBar.getValue();
                all=(int)(all*di);
                displayPanel.change();
                displayPanel.repaint();
                redBar.setValue(allBar.getValue());
                grnBar.setValue(allBar.getValue());
                bluBar.setValue(allBar.getValue());
            }
        }
}
//******************************************************************************
    class ButtonListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            JButton button = (JButton) e.getSource();
            if (button.equals(reverseButton)) {
                red=redBar.getValue();
                red=(int)(red*di);
                green =grnBar.getValue();
                green=(int)(green*di);
                blue  =bluBar.getValue();
                blue=(int)(blue*di);
                displayPanel.reverse();
                displayPanel.repaint();
            }
        }
    }
//******************************************************************************
    class DisplayPanel extends JPanel {
        Image displayImage;
        Image image;
        BufferedImage bi;
        Graphics2D big;
        DisplayPanel() {
            loadImage();
            change();
            setSize(displayImage.getWidth(this), displayImage.getWidth(this));
            createBufferedImage();
        }
        public void loadImage() {
            displayImage = Toolkit.getDefaultToolkit().getImage("D:/dekstopas/sitas.png");
            MediaTracker mt = new MediaTracker(this);
            mt.addImage(displayImage, 1);
            try {
                mt.waitForAll();
            }
            catch (Exception e) {
                System.out.println(".....");
            }
            if (displayImage.getWidth(this) == -1) {
                System.out.println("No jpg file");
                System.exit(0);
            }
        }
//******************************************************************************
     public void change() {
         PixelGrabber pg = new PixelGrabber(displayImage, 0, 0, -1, -1, pixels, 0, w);
         try{
             pg.grabPixels();
         }
         catch (InterruptedException e1){
             System.out.println("BED");
         }
         int index = 0;
         for (int h1 = 0; h1 < h; h1++){
             for (int w1 = 0; w1 < w; w1++){
                 reds   = ((pixels[index] >> 16)   & 0xff) *red /255;
                 greens  = ((pixels[index] >>  8)   & 0xff)*green/255;
                 blues   = ((pixels[index]  )       & 0xff)* blue/255;
                 alfas   = (pixels[index] >> 24)   & alfa;
                 pixels[index++] = (alfas << 24) | (reds << 16) | (greens << 8) | (blues);
             }
         }
         image = createImage(new MemoryImageSource(w, h, pixels, 0, w));
     }
 //******************************************************************************
     public void reverse() {
         redBar.setValue(100-(int)(red/di));
         bluBar.setValue(100-(int)(blue/di));
         grnBar.setValue(100-(int)(green/di));
    }
 //******************************************************************************
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D g2D = (Graphics2D) g;
        g2D.drawImage(image, 0, 0, this);
    }
//******************************************************************************
    public void createBufferedImage() {
        bi = new BufferedImage(displayImage.getWidth(this), displayImage.getHeight(this), BufferedImage.TYPE_INT_ARGB);
        big = bi.createGraphics();
        big.drawImage(image, 0, 0, this);
    }
}
}